function GCClassInheriter()
{
}

GCClassInheriter.copyUndefProperties = function(src, dest)
{
	for (var prop in src) {
		if (typeof(dest[prop]) == "undefined") { 
  	  dest[prop] = src[prop];
		}
	}
}

GCClassInheriter.inherit = function(subClass, superClass) 
{
	GCClassInheriter.copyUndefProperties(superClass, subClass);
	GCClassInheriter.copyUndefProperties(superClass.prototype, subClass.prototype);
}

function GCUninstallObserver(extId, prefPrefix)
{
	this.uninstalled = false;
	this.observerService = Components.classes["@mozilla.org/observer-service;1"].
	  							getService(Components.interfaces.nsIObserverService);
	this.extensionId = extId;
	this.query = prefPrefix;
	this.pref = Components.classes['@mozilla.org/preferences;1'].
	  						getService(Components.interfaces.nsIPrefBranch);
}

GCUninstallObserver.prototype.observe = function(aSubject, aTopic, aData)
{
	switch (aTopic) {
	  case "app-startup":
			this.observerService.addObserver(this, "em-action-requested", false);
      break;
    case "em-action-requested":
	    if (aSubject instanceof Components.interfaces.nsIUpdateItem 
	    		&& aSubject.id == this.extensionId) {
				this.analyzeAction(aData);
      }
      break;
		case "quit-application":
	    this.observerService.removeObserver(this, "em-action-requested");
      if (this.uninstalled) {
      	this.removeWorkDir();
      	this.clearPrefs();
      }
      break;
	}
}

GCUninstallObserver.prototype.analyzeAction = function(aData) {
	switch (aData) {
	  case "item-disabled":
      break;
		case "item-uninstalled":
	    this.uninstalled = true;
      break;
    case "item-cancel-action":
      this.uninstalled = false;
      break;
	}	
}

GCUninstallObserver.prototype.clearPrefs = function(query) {
	if (!query) query = this.query;
	if (!query) return;
	
	try {
 		var prefCount = { value: 0 };
  	var prefArray = this.pref.getChildList("", prefCount);
  	for (var i = 0; i < prefCount.value; i++) {
    	var prefName = prefArray[i];
      var re = new RegExp("^"+query);
    	if (re.test(prefName)) {
    		this.pref.clearUserPref(prefName);
    	}
  	}
	} catch(e) {
  }
}

GCUninstallObserver.prototype.clearPref = function(prefName) {
	try {
		this.pref.clearUserPref(prefName);
	} catch(e) {
	}
}

GCUninstallObserver.prototype.removeWorkDir = function() {
	var file = null;
	try {
		var value = this.pref.getComplexValue("gmcont.dump_rel_path", Components.interfaces.nsIRelativeFilePref);
		file = value.file;
		if (!file || !file.isWritable() || !file.isReadable()) file = null;
	} catch(e) {
		file = null;
	}
	
	try {
		if (!file) {
			file = Components.classes["@mozilla.org/file/directory_service;1"]
								.getService(Components.interfaces.nsIProperties)
								.get("ProfD", Components.interfaces.nsILocalFile);
			file.append("GoogleContacts");
		}
	} catch(e) {
		dump("Error: Cannot get dump dir.\n");
		file = null;
	}
	
	if (file && file.exists()) {
		file.remove(true);
	}
}

